package com.yidianling.muse.activity

import android.content.Intent
import android.graphics.Color
import android.os.Bundle
import android.os.Handler
import com.blankj.utilcode.util.SPUtils
import com.ydl.ydlcommon.base.BaseActivity
import com.ydl.ydlcommon.utils.StatusBarUtils
import com.ydl.ydlcommon.utils.remind.ToastHelper
import com.yidianling.muse.R
import jp.wasabeef.blurry.Blurry
import kotlinx.android.synthetic.main.activity_play_meditation_time_off.*
import kotlinx.android.synthetic.main.activity_play_meditation_time_off.iv_close

class MeditationTimeOffActivity : BaseActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        StatusBarUtils.setTransparentForImageView(this, null)
        StatusBarUtils.statusBarLightMode(this)
        super.onCreate(savedInstanceState)

        initView()
    }

    private fun initView() {

        Handler().postDelayed({
            Blurry.with(this)
                .radius(25)
                .sampling(1)
                .color(Color.parseColor("#FF173F5D"))
                .async()
                .capture(iv_bg)
                .into(iv_bg)
        },300)

        iv_close?.setOnClickListener { finish() }

        tv_save_setting?.setOnClickListener {
            ToastHelper.show("保存设置")
            val hour = wheel_hour.selectedItem
            val minute = wheel_minute.selectedItem

            val selectedHour = wheel_hour.selectedItem
            val selectedMinute = wheel_minute.selectedItem

            SPUtils.getInstance().put("SELECT_H",selectedHour)
            SPUtils.getInstance().put("SELECT_M",selectedMinute)

            val intent = Intent()
            if (hour is Int && minute is Int){
                val minute = (hour *60).plus(minute*5)
                intent.putExtra("TIME_OFF_MINUTE", minute)
            }
            setResult(RESULT_OK, intent)
            finish()
        }

        tv_cancel_time_off?.setOnClickListener {
            ToastHelper.show("关闭定时")
            SPUtils.getInstance().put("SELECT_H",0)
            SPUtils.getInstance().put("SELECT_M",1)
            val intent = Intent()
            intent.putExtra("TIME_OFF_MINUTE", 0)
            setResult(RESULT_OK, intent)
            finish()
        }

        initWheel()

    }

    private fun initWheel() {
        val selectionH = SPUtils.getInstance().getInt("SELECT_H",0)
        val selectionM = SPUtils.getInstance().getInt("SELECT_M",1)

        createHours()
        createMinutes()

        wheel_hour.setItems(hours)
        wheel_minute.setItems(minutes)

        wheel_hour.setInitPosition(selectionH)
        wheel_minute.setInitPosition(selectionM)

        wheel_hour.setListener { index ->
            if (index == 0 && wheel_minute.selectedItem == 0) {
                wheel_minute.setCurrentPosition(1)
            }
        }

        wheel_minute.setListener { index ->
            if (index == 0 && wheel_hour.selectedItem == 0) {
                wheel_minute.setCurrentPosition(1)
            }
        }


    }

    override fun initDataAndEvent() {
        StatusBarUtils.setWindowStatusBarColor(this, R.color.platform_main_theme)
    }

    override fun layoutResId(): Int {
        return R.layout.activity_play_meditation_time_off
    }

    private var hours = mutableListOf<String>()
    private var minutes = mutableListOf<String>()

    private fun createHours() {
        for (i in 0..23) {
            hours.add("" + i)
        }
    }

    private fun createMinutes() {
        var i = 0
        while (i < 60) {
            if (i < 10) {
                minutes.add("0$i")
            } else {
                minutes.add("" + i)
            }
            i += 5
        }
    }

}